# README: change the path to the directory that contains this file

setwd("/home/annie/workspaces/20100919-task-boundary/TaskBoundary/R/analyze-using-probability-beginning-or-end");
source("analyze-using-probability-beginning-or-end.R");
source("task-clustering.R");
source("edit-style.R");

print("loading tasks");
data<-loadTaskData();                    

print("add in attacher"); 
ppls<-loadPeople();
data<-merge(ppls,data);

print("what data to analysis?");
#c1="task.cluster";
c1="bug.severity";
c2="personal.editing.style"
#c2="editing.style"
#c2="expert.level"

print("loading events");
events<-merge(loadEvents(),data);

print("add in editing style");
traces =computePercentageOfEditsInBeginning(events);
editing.style.per.trace=computeEditingStyleBasedOnEditsInFirstHalf(traces);
data=merge(data,editing.style.per.trace,all.x=FALSE,all.y=FALSE)

print("cut off entries with less than 5 traces if we are analyzing personal editing style");
library(gdata)
more.than.5=moreThan5Traces(data);

print("just retain data with more than 5 traces")
data=merge(more.than.5,data,by="attacher",all.x=FALSE,all.y=FALSE); #inner join
data$attacher=drop.levels(data$attacher)
events=merge(more.than.5,events,all.x=FALSE,all.y=FALSE);  #inner join
events$attacher=drop.levels(events$attacher)

print("just retain traces from Mylyn");
setwd("../edit-style");
project.data=loadProjectData();
only.mylyn=subset(project.data, project.data$project=="Mylyn");
only.mylyn$project=drop.levels(only.mylyn$project)
data=merge(data,only.mylyn,by="bug.id",all.x=FALSE,all.y=FALSE)
data$project=drop.levels(data$project)
data$attacher=drop.levels(data$attacher)

# statistical test

library(car)

#editing.style.per.attacher=computePersonalEditingStyleBasedOnEditsInFirstHalf(data);
#editing.style.per.attacher=computePersonalEditingStyleBasedOnClustering(data);
editing.style.per.attacher=computePersonalEditingStyleBasedOnMedian(data);
bug.types.per.attacher=computeFractionsOfTaskTypes(data);
attacher.data=merge(bug.types.per.attacher,editing.style.per.attacher,by=c("attacher"))
summary(attacher.data)

table(attacher.data$edit.first.category)

# chi sq test -- no results
model = glm(attacher.data$edit.first 
  ~ attacher.data$enhancement * attacher.data$minor *attacher.data$normal)
Anova(model,type=2)
model = glm(attacher.data$edit.last.category 
  ~ attacher.data$enhancement.category * attacher.data$minor.category*attacher.data$normal.category,
  family = "binomial")
Anova(model,type=2); 
model = glm(attacher.data$edit.throughout.category
  ~ attacher.data$enhancement.category * attacher.data$minor.category*attacher.data$normal.category,
  family = "binomial")
Anova(model,type=2); 

# outlier test
#library(mvoutlier)
#outlier = aq.plot(attacher.data[c("edit.throughout","edit.last")]);
#outlier;
#attacher.data$outlier=data.frame(outlier);
#attacher.data=subset(attacher.data,attacher.data$outlier==FALSE) # eliminiate outliers

# normality test
library(mvnormtest);
Y = cbind(attacher.data$edit.throughout, attacher.data$edit.last);
mshapiro.test(t(Y));  # p=0.0025 which means we reject the  null hypothesis 
		      # that Y come from a normal distribution is false

# homogeneity of variances
bartlett.test(attacher.data$edit.throughout
  ~ attacher.data$enhancement.category
  * attacher.data$normal.category);
bartlett.test(attacher.data$edit.last~attacher.data$enhancement.category
  * attacher.data$normal.category);


#MANOVA
fit = manova(Y~ attacher.data$enhancement.category * attacher.data$normal.category
* attacher.data$minor.category)
summary(fit,test="Pillai");
summary(fit,test="Wilks");
summary(fit,test="Hotelling-Lawley")
summary(fit,test="Roy")


#write.csv(attacher.data,file="rq3-data.csv", sep=",",eol="\n",col.names=TRUE,row.names=FALSE);

