setwd("/home/annie/workspaces/20100919-task-boundary/TaskBoundary/R/analyze-using-probability-beginning-or-end");
source("analyze-using-probability-beginning-or-end.R");
source("task-clustering.R");
source("edit-style.R");

print("loading tasks");
data<-loadTaskData();                    

print("add in attacher"); 
ppls<-loadPeople();
data<-merge(ppls,data);

print("what data to analysis?");
#c1="task.cluster";
c1="bug.severity";
c2="personal.editing.style"
#c2="editing.style"
#c2="expert.level"

print("loading events");
events<-merge(loadEvents(),data);

print("add in editing style");
traces =computePercentageOfEditsInBeginning(events);
editing.style.per.trace=computeEditingStyleBasedOnEditsInFirstHalf(traces);
data=merge(data,editing.style.per.trace,all.x=FALSE,all.y=FALSE)

print("cut off entries with less than 5 traces if we are analyzing personal editing style");
library(gdata)
more.than.5=moreThanXTraces(data,5);
data=merge(more.than.5,data,by="attacher",all.x=FALSE,all.y=FALSE); #inner join
data$attacher=drop.levels(data$attacher)
events=merge(more.than.5,events,all.x=FALSE,all.y=FALSE);  #inner join
events$attacher=drop.levels(events$attacher)

m=data.frame(events$attachment.id, events$task.start, events$task.end);
names(m)=c("attachment.id","task.start","task.end")
m=unique(m)
d=data.frame(data$attachment.id, data$bug.severity); names(d)=c("attachment.id","bug.severity")
merged=merge(d,m,all.x=TRUE, all.y=FALSE,by="attachment.id");
merged$diff=merged$task.end-merged$task.start;
minor=subset(merged,merged$bug.severity=="minor")
normal=subset(merged,merged$bug.severity=="normal")
enh=subset(merged,merged$bug.severity=="enhancement")
kruskal.test(list(minor$diff,normal$diff,enh$diff))
# Kruskal-Wallis chi-squared = 283.8216, df = 2, p-value < 2.2e-16
wilcox.test(minor$diff,normal$diff) # W = 608249, p-value = 0.3251
wilcox.test(minor$diff,enh$diff)    # W = 187298, p-value < 2.2e-16
wilcox.test(normal$diff,enh$diff)   # W = 938512, p-value < 2.2e-16
pairwise.wilcox.test(
  c(minor$diff,normal$diff,enh$diff),
  c(rep("minor",times=1,each=length(minor$diff)),
    rep("normal",times=1,each=length(normal$diff)),
    rep("enh",times=1,each=length(enh$diff))), p.adj="bonferroni")