loadTaskData <-function() {
  #setwd("/home/annie/workspaces/20100919-task-boundary/TaskBoundary/R");
  #setwd("../trace-clustering");
  bugs<-read.csv(file="task-clustering-features.csv",sep=",",head=TRUE);
  attachments<-read.csv(file="attachment-to-bug-ids.csv",sep=",",head=TRUE);
  bugs<-merge(bugs,attachments);
  bugs<-binBugSeverity(bugs);
  bugs<-categorize(bugs);
  bugs
}

binBugSeverity <-function(data) {
  bugs<-subset(data,data$bug.severity=="normal" | data$bug.severity=="major" |data$bug.severity=="critical" | data$bug.severity=="blocker");
  bugs$bug.severity<-"normal";

  enhancement<-subset(data,data$bug.severity=="enhancement");

  minor<-subset(data,data$bug.severity=="trivial" | data$bug.severity=="minor");
  minor$bug.severity<-"minor";

  normalized<-rbind(bugs,enhancement,minor)
  normalized
}

categorize <-function(data) {
  data$bug.severity<-as.factor(data$bug.severity)
  data$contain.stack.trace<-as.factor(data$contain.stack.trace)
  data$bug.id<-as.factor(data$bug.id);
  data
}

clusterTasksByTaskFeature <- function() {
  data<-loadTaskData();

  attrs <- names(data) %in% c("number.of.comments","bug.severity","contain.stack.trace") 
  d2 <-data[attrs]

  library(cluster)
  numberOfClusters=4; # 4 is the best number of clusters
		      # with a high silhouette width and a balanced number of clusters
  result<-pam(daisy(d2),k=numberOfClusters)
  data<-data.frame(data,result$clustering)  # add the cluster number back to the data
  for( i in 1:numberOfClusters ) {
    print(data[result$medoids[i],2:4])
  }

  names(data)[names(data)=="result.clustering"]="task.cluster";
  data$task.cluster=as.factor(data$task.cluster)
  data
}

#tasks<-clusterTasksByTaskFeature()
#plot(result); # plot silhouette graph to see if the clusters we got are good


